include	BitmapToJPEG.inc
include	gdi+.inc

UnicodeStr			PROTO :DWORD,:DWORD
GetEncoderClsid		PROTO :DWORD,:DWORD
WriteFileToDisc		PROTO :DWORD,:DWORD,:DWORD
CopyGUID			PROTO :DWORD,:DWORD

.data

szBMPfile			db 'test.bmp',0
szJPEGfile			db 'test.jpg',0
ImgType				db 'image/jpeg',0
message				db 'BMP converted to JPEG',0
caption				db 'GDI+ test',0
CompressionLevel	dd  80
_EncoderQuality		GUID <01d5be4b5h,0fa4ah,0452dh,<09ch,0ddh,05dh,0b3h,051h,05h,0e7h,0ebh>>
dlibMove			LARGE_INTEGER <0>
plibNewPosition		LARGE_INTEGER <0>

.data?
StartupInfo			GdiplusStartupInput <?>
buffer				db 32 dup(?)
pImageCodecInfo		dd ?
token				dd ?
BmpImage			dd ?
eps					EncoderParameters <?>
pMemory				dd ?
pStream				dd ?
hGlobal				dd ?

.code

start:

	mov		eax,OFFSET StartupInfo
	mov		GdiplusStartupInput.GdiplusVersion[eax],1
												; must be always set to 1
	invoke	GdiplusStartup,ADDR token,ADDR StartupInfo,0
	invoke	UnicodeStr,ADDR szBMPfile,ADDR buffer
												; convert szBMPfile to UNICODE

	invoke	GdipCreateBitmapFromFile,ADDR buffer,ADDR BmpImage
												; load the bitmap file to memory
												
	mov		esi,OFFSET eps
	mov		EncoderParameters.Count[esi],1		; process only one EncoderParameter structure
	lea		edx,[esi+EncoderParameters.Parameter.pGUID]

	invoke	CopyGUID,ADDR _EncoderQuality,edx	; copy the GUID

	mov		EncoderParameters.Parameter.vType[esi],EncoderParameterValueTypeLong
	mov		EncoderParameters.Parameter.NumberOfValues[esi],1
												; we have only one EncoderParameter structure

	mov		EncoderParameters.Parameter.value[esi],OFFSET CompressionLevel
												; set the JPEG compression level

	invoke	CreateStreamOnHGlobal,0,TRUE,ADDR pStream
												; create a new stream
												; fDeleteOnRelease set to TRUE means that hGlobal
												; will be released automatically by the IStream::Release method

	invoke	GetEncoderClsid,ADDR ImgType,ADDR pImageCodecInfo
												; get the class identifier (CLSID) of the encoder
												; The encoder can be bmp,jpeg,gif,tiff or png
	
	invoke	GdipSaveImageToStream,BmpImage,pStream,eax,ADDR eps
												; save the JPEG image to stream

	invoke	GetHGlobalFromStream,pStream,ADDR hGlobal
												; get the global handle to the stream
												; created by CreateStreamOnHGlobal

	invoke	GlobalLock,hGlobal					; get the address of the memory block containing the JPEG image
	mov		pMemory,eax

	mov		edx,OFFSET dlibMove
	mov		eax,pStream
	push	OFFSET plibNewPosition				; the displacement to be added to STREAM_SEEK_END
	push	STREAM_SEEK_END						; move the pointer to end of the stream
	push	DWORD PTR [edx+4]					; pass the structure dlibMove to the stack
	push	DWORD PTR [edx]
	push	eax
	mov		eax,DWORD PTR [eax]
	call	IStream.Seek[eax]					; the IStream::Seek method changes the seek pointer to a new location

	invoke	WriteFileToDisc,ADDR szJPEGfile,pMemory,DWORD PTR [plibNewPosition]
												; DWORD PTR [plibNewPosition] = low-order DWORD of stream size

	mov		eax,pStream		
	push	eax
    mov		eax,DWORD PTR [eax]
    call	IStream.IUnknown.Release[eax]		; release the stream

	invoke	VirtualFree,pImageCodecInfo,0,MEM_RELEASE

	invoke	GdipDisposeImage,BmpImage			; release the image
	invoke	GdiplusShutdown,token				; shutdown the GDI+ system
	invoke	MessageBox,0,ADDR message,ADDR caption,MB_OK
	invoke	ExitProcess,0

GetEncoderClsid PROC USES ebx edi sMimeType:DWORD,pMem:DWORD

LOCAL numEncoders:DWORD
LOCAL nSize:DWORD
LOCAL _buffer[32]:BYTE

	invoke	GdipGetImageEncodersSize,ADDR numEncoders,ADDR nSize
												; get the number of available image encoders
												; and the total size of the array
												; of ImageCodecInfo structures
	invoke	VirtualAlloc,0,nSize,MEM_COMMIT,PAGE_READWRITE
	mov		edi,eax
	mov		edx,pMem	 						; = pImageCodecInfo
	mov		DWORD PTR [edx],eax
	invoke	GdipGetImageEncoders,numEncoders,nSize,edi
												; get an array of ImageCodecInfo
												; structures that contain information
												; about the available image encoders
	invoke	UnicodeStr,sMimeType,ADDR _buffer
	mov		ebx,numEncoders
@@:
	invoke	StrCmpW,ADDR _buffer,ImageCodecInfo.MimeType[edi]
	test	eax,eax
	jnz		@f
	sub		ebx,1
	add		edi,SIZEOF ImageCodecInfo
	jmp		@b
@@:
	mov		eax,edi								; = lea	eax,[edi+ImageCodecInfo.Clsid]
	ret											; eax holds the class identifier (CLSID)
												; of the JPEG encoder

GetEncoderClsid ENDP

UnicodeStr	PROC USES esi Source:DWORD,Dest:DWORD
												; convert a string to UNICODE
	mov		esi,Source
	mov		edx,Dest
	xor		eax,eax
	sub		eax,1
@@:
	add		eax,1
	movzx	ecx,BYTE PTR [esi+eax]
	mov		WORD PTR [edx+eax*2],cx
	test	ecx,ecx
	jnz		@b
	ret

UnicodeStr	ENDP

align 4

CopyGUID PROC USES esi edi Source:DWORD,Dest:DWORD

    cld
	mov		esi,Source
	mov     edi,Dest
    mov		ecx,4								; SIZEOF(GUID) \ 4 = 4
    rep     movsd
    ret

CopyGUID ENDP

END start
